Index: palm/trunk/TESTS/cases/urban_environment_salsa/MONITORING/urban_environment_salsa_rc.000
===================================================================
--- palm/trunk/TESTS/cases/urban_environment_salsa/MONITORING/urban_environment_salsa_rc.000	(revision 4661)
+++ palm/trunk/TESTS/cases/urban_environment_salsa/MONITORING/urban_environment_salsa_rc.000	(revision 4669)
@@ -1,9 +1,9 @@
 
  ******************************    --------------------------------------------
- * PALM 6.0  Rev: 4660M       *    atmosphere - run without 1D - prerun
+ * PALM 6.0  Rev: 4668M       *    atmosphere - run without 1D - prerun
  ******************************    --------------------------------------------
 
- Date:               2020-09-01    Run:       urban_environment_salsa__gfortran_
- Time:                 17:52:30    Run-No.:   00
+ Date:               2020-09-09    Run:       urban_environment_salsa__gfortran_
+ Time:                 15:27:22    Run-No.:   00
  Run on host:        gfortran_d
  Number of PEs:               4    Processor grid (x,y): (   2,   2) calculated
@@ -331,6 +331,6 @@
   0      0 00:00:00.00   0.7580A  -2.3731D -1.1942D  0.4177  0.064  0.00  -0.207E+00     16.  0.137E+01  0.743E-02  0.234E-01  0.446E-02   60  17  18   19   0  14   20  18   0    0.000    0.000       0
   0      1 00:00:00.75   0.7580A  -2.3732  -1.5382   0.7410  0.085  0.33  -0.907E+00      2.  0.137E+01  0.116E-01  0.268E-02  0.892E-03   60  18  15   16  15   0   20  18   0    0.000    0.000       0
-  0      2 00:00:01.51   0.7580A  -2.3733  -1.6029   0.8137  0.084  0.00  -0.928E+00      2.  0.137E+01  0.125E-01  0.953E-03  0.351E-03   60  17  14   16  15   0   20  17   0    0.000    0.000       0
-  0      3 00:00:02.27   0.7580A  -2.3733  -1.5857   0.8392  0.083  0.00  -0.950E+00      2.  0.137E+01  0.129E-01  0.818E-03  0.240E-03   60  17  13   17  15   0   20  17   0    0.000    0.000       0
+  0      2 00:00:01.51   0.7580A  -2.3733  -1.6029   0.8137  0.084  0.00  -0.933E+00      2.  0.137E+01  0.125E-01  0.953E-03  0.351E-03   60  17  14   16  15   0   20  17   0    0.000    0.000       0
+  0      3 00:00:02.27   0.7580A  -2.3733  -1.5857   0.8392  0.083  0.00  -0.948E+00      2.  0.137E+01  0.129E-01  0.818E-03  0.240E-03   60  17  13   17  15   0   20  17   0    0.000    0.000       0
   0      4 00:00:03.03   0.7580A  -2.3734  -1.5379   0.8466  0.083  0.13  -0.960E+00     12.  0.137E+01  0.132E-01  0.778E-03  0.213E-03   60  17  13   17  15   0   20  17   0    0.000    0.000       0
   0      5 00:00:03.79   0.7580A  -2.3735  -1.5015   0.8447  0.082  0.17  -0.967E+00     12.  0.137E+01  0.134E-01  0.769E-03  0.205E-03   60  17  12   17  14   0   20  17   0    0.000    0.000       0
@@ -338,35 +338,35 @@
   0      7 00:00:05.30   0.7580A  -2.3736  -1.4293   0.8324  0.081  0.24  -0.974E+00     18.  0.137E+01  0.140E-01  0.760E-03  0.199E-03   60  16  10   11  14   0   20  17   0    0.000    0.000       0
   0      8 00:00:06.06   0.7580A  -2.3737  -1.3992   0.8253  0.080  0.25  -0.975E+00     18.  0.137E+01  0.143E-01  0.759E-03  0.198E-03   60  16  10   11  14   0   20  17   0    0.000    0.000       0
-  0      9 00:00:06.82   0.7580A  -2.3738  -1.3712   0.8180  0.080  0.26  -0.976E+00     18.  0.137E+01  0.146E-01  0.760E-03  0.197E-03   60  16   9   11  14   0   20  17   0    0.000    0.000       0
+  0      9 00:00:06.82   0.7580A  -2.3738  -1.3712   0.8181  0.080  0.26  -0.977E+00     18.  0.137E+01  0.146E-01  0.760E-03  0.197E-03   60  16   9   11  14   0   20  17   0    0.000    0.000       0
   0     10 00:00:07.58   0.7580A  -2.3739  -1.3483   0.8112  0.079  0.26  -0.978E+00     18.  0.137E+01  0.150E-01  0.761E-03  0.196E-03   60  15   8   11  14   0   20  17   0    0.000    0.000       0
-  0     11 00:00:08.33   0.7580A  -2.3739  -1.3295   0.8054  0.079  0.26  -0.978E+00     18.  0.137E+01  0.153E-01  0.764E-03  0.196E-03   60  15   7   11  14   0   20  17   0    0.000    0.000       0
-  0     12 00:00:09.09   0.7580A  -2.3740  -1.3242   0.8010  0.078  0.27  -0.979E+00     18.  0.136E+01  0.157E-01  0.768E-03  0.196E-03   60  14   6   16  14   0   20  17   0    0.000    0.000       0
-  0     13 00:00:09.85   0.7580A  -2.3741  -1.3191   0.7984  0.078  0.27  -0.980E+00     18.  0.136E+01  0.161E-01  0.773E-03  0.196E-03   60  14   6   16  14   0   20  17   0    0.000    0.000       0
-  0     14 00:00:10.61   0.7580A  -2.3742  -1.3107   0.7972  0.077  0.28  -0.980E+00     18.  0.136E+01  0.165E-01  0.778E-03  0.195E-03   60  14   5   16  14   0   20  17   0    0.000    0.000       0
-  0     15 00:00:11.37   0.7580A  -2.3743  -1.2987   0.8183  0.077  0.28  -0.981E+00     18.  0.136E+01  0.169E-01  0.782E-03  0.195E-03   60  13   4   16  14   0   11  14  18    0.000    0.000       0
-  0     16 00:00:12.12   0.7580A  -2.3743  -1.2833   0.8548  0.076  0.35  -0.981E+00     28.  0.136E+01  0.173E-01  0.785E-03  0.194E-03   60  13   3   16  14   0   11  14  18    0.000    0.000       0
-  0     17 00:00:12.88   0.7580A  -2.3744  -1.2644   0.8840  0.076  0.35  -0.980E+00     28.  0.136E+01  0.177E-01  0.788E-03  0.193E-03   60  12   2   16  14   0   11  14  18    0.000    0.000       0
-  0     18 00:00:13.64   0.7580A  -2.3745  -1.2477   0.9195  0.076  0.36  -0.979E+00     28.  0.136E+01  0.181E-01  0.792E-03  0.192E-03   60  12   1   11  14   0   10  14  18    0.000    0.000       0
-  0     19 00:00:14.40   0.7580A  -2.3746  -1.2430   0.9579  0.075  0.42  -0.978E+00     40.  0.136E+01  0.186E-01  0.796E-03  0.190E-03   60  12   1   11  14   0   10  14  18    0.000    0.000       0
-  0     20 00:00:15.16   0.7580A  -2.3746  -1.2392   0.9938  0.075  0.42  -0.977E+00     40.  0.136E+01  0.190E-01  0.799E-03  0.189E-03   60  12   0   11  14   0   10  14  18    0.000    0.000       0
-  0     21 00:00:15.91   0.7580A  -2.3747  -1.2361   1.0254  0.075  0.43  -0.976E+00     40.  0.136E+01  0.195E-01  0.802E-03  0.187E-03   60  11  19   11  14   0   10  14  18    0.000    0.000       0
-  0     22 00:00:16.67   0.7580A  -2.3748  -1.2334   1.0514  0.074  0.43  -0.976E+00     40.  0.136E+01  0.200E-01  0.806E-03  0.186E-03   60  11  18   11  14   0   10  14  18    0.000    0.000       0
-  0     23 00:00:17.43   0.7580A  -2.3749  -1.2312   1.0713  0.074  0.44  -0.975E+00     40.  0.136E+01  0.204E-01  0.809E-03  0.185E-03   60  10  17   11  14   0   10  14  18    0.000    0.000       0
-  0     24 00:00:18.19   0.7580A  -2.3749  -1.2294   1.0868  0.074  0.44  -0.974E+00     40.  0.136E+01  0.209E-01  0.812E-03  0.183E-03   60  10  16   11  14   0   11  14  18    0.000    0.000       0
-  0     25 00:00:18.95   0.7580A  -2.3750  -1.2278   1.1141  0.074  0.45  -0.974E+00     40.  0.136E+01  0.214E-01  0.817E-03  0.182E-03   60  10  16   11  14   0   11  14  18    0.000    0.000       0
-  0     26 00:00:19.70   0.7580A  -2.3751  -1.2266   1.1359  0.073  0.45  -0.973E+00     40.  0.136E+01  0.219E-01  0.821E-03  0.181E-03   60  10  15   11  14   0   11  14  18    0.000    0.000       0
-  0     27 00:00:20.46   0.7580A  -2.3752  -1.2256   1.1510  0.073  0.46  -0.973E+00     40.  0.136E+01  0.224E-01  0.825E-03  0.180E-03   60   9  14   11  14   0   11  14  18    0.000    0.000       0
-  0     28 00:00:21.22   0.7580A  -2.3752  -1.2247   1.1596  0.073  0.46  -0.972E+00     40.  0.136E+01  0.229E-01  0.829E-03  0.179E-03   60   9  13   11  14   0   11  14  18    0.000    0.000       0
-  0     29 00:00:21.98   0.7580A  -2.3753  -1.2237   1.1624  0.073  0.46  -0.972E+00     40.  0.136E+01  0.234E-01  0.834E-03  0.179E-03   60   9  12   11  14   0   11  14  18    0.000    0.000       0
-  0     30 00:00:22.74   0.7580A  -2.3754  -1.2224   1.1607  0.072  0.47  -0.971E+00     40.  0.136E+01  0.239E-01  0.840E-03  0.178E-03   60   8  11   11  14   0   11  14  18    0.000    0.000       0
-  0     31 00:00:23.49   0.7580A  -2.3755  -1.2207   1.1562  0.072  0.47  -0.971E+00     40.  0.136E+01  0.244E-01  0.846E-03  0.178E-03   60   8  10   11  14   0   11  14  18    0.000    0.000       0
-  0     32 00:00:24.25   0.7580A  -2.3756  -1.2184   1.1524  0.072  0.47  -0.971E+00     40.  0.136E+01  0.250E-01  0.853E-03  0.177E-03   60   8  10   11  14   0   13  14  18    0.000    0.000       0
-  0     33 00:00:25.01   0.7580A  -2.3756  -1.2151   1.1588  0.072  0.48  -0.971E+00     40.  0.136E+01  0.255E-01  0.860E-03  0.177E-03   60   7   9   11  14   0   13  14  18    0.000    0.000       0
-  0     34 00:00:25.77   0.7580A  -2.3757  -1.2105   1.1879  0.072  0.48  -0.971E+00     40.  0.136E+01  0.261E-01  0.866E-03  0.177E-03   60   7   8   11  14   0   11  14  17    0.000    0.000       0
-  0     35 00:00:26.53   0.7580A  -2.3758  -1.2044   1.2127  0.071  0.48  -0.970E+00     40.  0.136E+01  0.266E-01  0.873E-03  0.177E-03   60   7   7   11  14   0   11  14  17    0.000    0.000       0
-  0     36 00:00:27.28   0.7580A  -2.3759  -1.1963   1.2272  0.071  0.49  -0.970E+00     40.  0.136E+01  0.272E-01  0.881E-03  0.177E-03   60   6   6   11  14   0   11  14  17    0.000    0.000       0
-  0     37 00:00:28.04   0.7580A  -2.3759  -1.1860   1.2410  0.071  0.49  -0.970E+00     40.  0.136E+01  0.278E-01  0.889E-03  0.177E-03   60   6   5   11  14   0   12  14  17    0.000    0.000       0
-  0     38 00:00:28.80   0.7580A  -2.3760  -1.1734   1.2634  0.071  0.49  -0.970E+00     40.  0.136E+01  0.284E-01  0.896E-03  0.178E-03   60   6   4   11  14   0   14  14  16    0.000    0.000       0
-  0     39 00:00:29.56   0.7580A  -2.3761  -1.1619   1.2905  0.071  0.50  -0.970E+00     40.  0.136E+01  0.290E-01  0.905E-03  0.178E-03   60   5   3   11  13   0   14  14  16    0.000    0.000       0
-  0     40 00:00:30.32   0.7580A  -2.3762  -1.1510   1.3236  0.071  0.50  -0.969E+00     40.  0.136E+01  0.296E-01  0.914E-03  0.179E-03   60   5   3   11  13   0   12  14  16    0.000    0.000       0
-  0     41 00:00:31.07   0.7580A  -2.3762  -1.1370   1.3551  0.070  0.50  -0.969E+00     40.  0.136E+01  0.302E-01  0.922E-03  0.179E-03   60   5   2   11  13   0   13  14  16    0.000    0.000       0
+  0     11 00:00:08.33   0.7580A  -2.3739  -1.3295   0.8054  0.079  0.26  -0.979E+00     18.  0.137E+01  0.153E-01  0.764E-03  0.196E-03   60  15   7   11  14   0   20  17   0    0.000    0.000       0
+  0     12 00:00:09.09   0.7580A  -2.3740  -1.3242   0.8010  0.078  0.27  -0.980E+00     18.  0.136E+01  0.157E-01  0.768E-03  0.196E-03   60  14   6   16  14   0   20  17   0    0.000    0.000       0
+  0     13 00:00:09.85   0.7580A  -2.3741  -1.3191   0.7984  0.078  0.27  -0.980E+00     18.  0.136E+01  0.161E-01  0.773E-03  0.196E-03   60  14   5   16  14   0   20  17   0    0.000    0.000       0
+  0     14 00:00:10.61   0.7580A  -2.3742  -1.3107   0.7972  0.077  0.28  -0.981E+00     18.  0.136E+01  0.165E-01  0.778E-03  0.195E-03   60  14   5   16  14   0   20  17   0    0.000    0.000       0
+  0     15 00:00:11.37   0.7580A  -2.3743  -1.2987   0.8185  0.077  0.28  -0.981E+00     18.  0.136E+01  0.169E-01  0.782E-03  0.195E-03   60  13   4   16  14   0   11  14  18    0.000    0.000       0
+  0     16 00:00:12.12   0.7580A  -2.3743  -1.2833   0.8550  0.076  0.35  -0.981E+00     28.  0.136E+01  0.173E-01  0.785E-03  0.194E-03   60  13   3   16  14   0   11  14  18    0.000    0.000       0
+  0     17 00:00:12.88   0.7580A  -2.3744  -1.2644   0.8842  0.076  0.35  -0.980E+00     28.  0.136E+01  0.177E-01  0.788E-03  0.193E-03   60  12   2   16  14   0   11  14  18    0.000    0.000       0
+  0     18 00:00:13.64   0.7580A  -2.3745  -1.2477   0.9197  0.076  0.36  -0.979E+00     28.  0.136E+01  0.181E-01  0.792E-03  0.192E-03   60  12   1   11  14   0   10  14  18    0.000    0.000       0
+  0     19 00:00:14.40   0.7580A  -2.3746  -1.2430   0.9580  0.075  0.42  -0.978E+00     40.  0.136E+01  0.186E-01  0.796E-03  0.190E-03   60  12   1   11  14   0   10  14  18    0.000    0.000       0
+  0     20 00:00:15.16   0.7580A  -2.3746  -1.2392   0.9940  0.075  0.42  -0.978E+00     40.  0.136E+01  0.190E-01  0.799E-03  0.189E-03   60  12   0   11  14   0   10  14  18    0.000    0.000       0
+  0     21 00:00:15.91   0.7580A  -2.3747  -1.2361   1.0256  0.075  0.43  -0.977E+00     40.  0.136E+01  0.195E-01  0.802E-03  0.187E-03   60  11  19   11  14   0   10  14  18    0.000    0.000       0
+  0     22 00:00:16.67   0.7580A  -2.3748  -1.2335   1.0516  0.074  0.43  -0.977E+00     40.  0.136E+01  0.200E-01  0.806E-03  0.186E-03   60  11  18   11  14   0   10  14  18    0.000    0.000       0
+  0     23 00:00:17.43   0.7580A  -2.3749  -1.2312   1.0716  0.074  0.44  -0.976E+00     40.  0.136E+01  0.204E-01  0.809E-03  0.185E-03   60  10  17   11  14   0   10  14  18    0.000    0.000       0
+  0     24 00:00:18.19   0.7580A  -2.3749  -1.2294   1.0871  0.074  0.44  -0.975E+00     40.  0.136E+01  0.209E-01  0.812E-03  0.183E-03   60  10  16   11  14   0   11  14  18    0.000    0.000       0
+  0     25 00:00:18.95   0.7580A  -2.3750  -1.2278   1.1145  0.074  0.45  -0.975E+00     40.  0.136E+01  0.214E-01  0.816E-03  0.182E-03   60  10  16   11  14   0   11  14  18    0.000    0.000       0
+  0     26 00:00:19.70   0.7580A  -2.3751  -1.2266   1.1362  0.073  0.45  -0.974E+00     40.  0.136E+01  0.219E-01  0.821E-03  0.181E-03   60  10  15   11  14   0   11  14  18    0.000    0.000       0
+  0     27 00:00:20.46   0.7580A  -2.3752  -1.2256   1.1514  0.073  0.46  -0.973E+00     40.  0.136E+01  0.224E-01  0.825E-03  0.180E-03   60   9  14   11  14   0   11  14  18    0.000    0.000       0
+  0     28 00:00:21.22   0.7580A  -2.3752  -1.2247   1.1600  0.073  0.46  -0.973E+00     40.  0.136E+01  0.229E-01  0.829E-03  0.179E-03   60   9  13   11  14   0   11  14  18    0.000    0.000       0
+  0     29 00:00:21.98   0.7580A  -2.3753  -1.2236   1.1628  0.073  0.46  -0.973E+00     40.  0.136E+01  0.234E-01  0.834E-03  0.179E-03   60   9  12   11  14   0   11  14  18    0.000    0.000       0
+  0     30 00:00:22.74   0.7580A  -2.3754  -1.2224   1.1611  0.072  0.47  -0.972E+00     40.  0.136E+01  0.239E-01  0.840E-03  0.178E-03   60   8  11   11  14   0   11  14  18    0.000    0.000       0
+  0     31 00:00:23.49   0.7580A  -2.3755  -1.2207   1.1566  0.072  0.47  -0.972E+00     40.  0.136E+01  0.244E-01  0.846E-03  0.178E-03   60   8  10   11  14   0   11  14  18    0.000    0.000       0
+  0     32 00:00:24.25   0.7580A  -2.3755  -1.2184   1.1530  0.072  0.47  -0.972E+00     40.  0.136E+01  0.250E-01  0.853E-03  0.177E-03   60   8  10   11  14   0   13  14  18    0.000    0.000       0
+  0     33 00:00:25.01   0.7580A  -2.3756  -1.2150   1.1594  0.072  0.48  -0.972E+00     40.  0.136E+01  0.255E-01  0.860E-03  0.177E-03   60   7   9   11  14   0   13  14  18    0.000    0.000       0
+  0     34 00:00:25.77   0.7580A  -2.3757  -1.2104   1.1885  0.072  0.48  -0.972E+00     40.  0.136E+01  0.261E-01  0.866E-03  0.177E-03   60   7   8   11  14   0   11  14  17    0.000    0.000       0
+  0     35 00:00:26.53   0.7580A  -2.3758  -1.2042   1.2133  0.071  0.48  -0.972E+00     40.  0.136E+01  0.266E-01  0.874E-03  0.177E-03   60   7   7   11  14   0   11  14  17    0.000    0.000       0
+  0     36 00:00:27.28   0.7580A  -2.3759  -1.1961   1.2278  0.071  0.49  -0.971E+00     40.  0.136E+01  0.272E-01  0.881E-03  0.177E-03   60   6   6   11  14   0   11  14  17    0.000    0.000       0
+  0     37 00:00:28.04   0.7580A  -2.3759  -1.1858   1.2418  0.071  0.49  -0.971E+00     40.  0.136E+01  0.278E-01  0.889E-03  0.177E-03   60   6   5   11  14   0   12  14  17    0.000    0.000       0
+  0     38 00:00:28.80   0.7580A  -2.3760  -1.1731   1.2645  0.071  0.49  -0.971E+00     40.  0.136E+01  0.284E-01  0.896E-03  0.178E-03   60   6   5   11  14   0   14  14  16    0.000    0.000       0
+  0     39 00:00:29.56   0.7580A  -2.3761  -1.1617   1.2916  0.071  0.50  -0.971E+00     40.  0.136E+01  0.290E-01  0.905E-03  0.178E-03   60   5   3   11  13   0   14  14  16    0.000    0.000       0
+  0     40 00:00:30.32   0.7580A  -2.3762  -1.1508   1.3247  0.071  0.50  -0.970E+00     40.  0.136E+01  0.296E-01  0.914E-03  0.179E-03   60   5   3   11  13   0   12  14  16    0.000    0.000       0
+  0     41 00:00:31.07   0.7580A  -2.3762  -1.1366   1.3565  0.070  0.50  -0.970E+00     40.  0.136E+01  0.302E-01  0.923E-03  0.179E-03   60   5   2   11  13   0   13  14  16    0.000    0.000       0