Index: palm/trunk/TESTS/cases/urban_environment_salsa/MONITORING/urban_environment_salsa_rc.000
===================================================================
--- palm/trunk/TESTS/cases/urban_environment_salsa/MONITORING/urban_environment_salsa_rc.000	(revision 4699)
+++ palm/trunk/TESTS/cases/urban_environment_salsa/MONITORING/urban_environment_salsa_rc.000	(revision 4702)
@@ -1,9 +1,9 @@
 
  ******************************    --------------------------------------------
- * PALM 6.0  Rev: 4668M       *    atmosphere - run without 1D - prerun
+ * PALM 6.0  Rev: 4700:47     *    atmosphere - run without 1D - prerun
  ******************************    --------------------------------------------
 
- Date:               2020-09-09    Run:       urban_environment_salsa__gfortran_
- Time:                 15:27:22    Run-No.:   00
+ Date:               2020-09-27    Run:       urban_environment_salsa__gfortran_
+ Time:                 19:55:36    Run-No.:   00
  Run on host:        gfortran_d
  Number of PEs:               4    Processor grid (x,y): (   2,   2) calculated
@@ -337,5 +337,5 @@
   0      6 00:00:04.54   0.7580A  -2.3736  -1.4553   0.8392  0.081  0.23  -0.971E+00     18.  0.137E+01  0.137E-01  0.763E-03  0.201E-03   60  17  11   17  14   0   20  17   0    0.000    0.000       0
   0      7 00:00:05.30   0.7580A  -2.3736  -1.4293   0.8324  0.081  0.24  -0.974E+00     18.  0.137E+01  0.140E-01  0.760E-03  0.199E-03   60  16  10   11  14   0   20  17   0    0.000    0.000       0
-  0      8 00:00:06.06   0.7580A  -2.3737  -1.3992   0.8253  0.080  0.25  -0.975E+00     18.  0.137E+01  0.143E-01  0.759E-03  0.198E-03   60  16  10   11  14   0   20  17   0    0.000    0.000       0
+  0      8 00:00:06.06   0.7580A  -2.3737  -1.3992   0.8253  0.080  0.25  -0.976E+00     18.  0.137E+01  0.143E-01  0.759E-03  0.198E-03   60  16  10   11  14   0   20  17   0    0.000    0.000       0
   0      9 00:00:06.82   0.7580A  -2.3738  -1.3712   0.8181  0.080  0.26  -0.977E+00     18.  0.137E+01  0.146E-01  0.760E-03  0.197E-03   60  16   9   11  14   0   20  17   0    0.000    0.000       0
   0     10 00:00:07.58   0.7580A  -2.3739  -1.3483   0.8112  0.079  0.26  -0.978E+00     18.  0.137E+01  0.150E-01  0.761E-03  0.196E-03   60  15   8   11  14   0   20  17   0    0.000    0.000       0
@@ -344,29 +344,29 @@
   0     13 00:00:09.85   0.7580A  -2.3741  -1.3191   0.7984  0.078  0.27  -0.980E+00     18.  0.136E+01  0.161E-01  0.773E-03  0.196E-03   60  14   5   16  14   0   20  17   0    0.000    0.000       0
   0     14 00:00:10.61   0.7580A  -2.3742  -1.3107   0.7972  0.077  0.28  -0.981E+00     18.  0.136E+01  0.165E-01  0.778E-03  0.195E-03   60  14   5   16  14   0   20  17   0    0.000    0.000       0
-  0     15 00:00:11.37   0.7580A  -2.3743  -1.2987   0.8185  0.077  0.28  -0.981E+00     18.  0.136E+01  0.169E-01  0.782E-03  0.195E-03   60  13   4   16  14   0   11  14  18    0.000    0.000       0
+  0     15 00:00:11.37   0.7580A  -2.3743  -1.2987   0.8185  0.077  0.28  -0.982E+00     18.  0.136E+01  0.169E-01  0.782E-03  0.195E-03   60  13   4   16  14   0   11  14  18    0.000    0.000       0
   0     16 00:00:12.12   0.7580A  -2.3743  -1.2833   0.8550  0.076  0.35  -0.981E+00     28.  0.136E+01  0.173E-01  0.785E-03  0.194E-03   60  13   3   16  14   0   11  14  18    0.000    0.000       0
   0     17 00:00:12.88   0.7580A  -2.3744  -1.2644   0.8842  0.076  0.35  -0.980E+00     28.  0.136E+01  0.177E-01  0.788E-03  0.193E-03   60  12   2   16  14   0   11  14  18    0.000    0.000       0
-  0     18 00:00:13.64   0.7580A  -2.3745  -1.2477   0.9197  0.076  0.36  -0.979E+00     28.  0.136E+01  0.181E-01  0.792E-03  0.192E-03   60  12   1   11  14   0   10  14  18    0.000    0.000       0
-  0     19 00:00:14.40   0.7580A  -2.3746  -1.2430   0.9580  0.075  0.42  -0.978E+00     40.  0.136E+01  0.186E-01  0.796E-03  0.190E-03   60  12   1   11  14   0   10  14  18    0.000    0.000       0
+  0     18 00:00:13.64   0.7580A  -2.3745  -1.2477   0.9196  0.076  0.36  -0.980E+00     28.  0.136E+01  0.181E-01  0.792E-03  0.192E-03   60  12   1   11  14   0   10  14  18    0.000    0.000       0
+  0     19 00:00:14.40   0.7580A  -2.3746  -1.2430   0.9580  0.075  0.42  -0.979E+00     40.  0.136E+01  0.186E-01  0.796E-03  0.190E-03   60  12   1   11  14   0   10  14  18    0.000    0.000       0
   0     20 00:00:15.16   0.7580A  -2.3746  -1.2392   0.9940  0.075  0.42  -0.978E+00     40.  0.136E+01  0.190E-01  0.799E-03  0.189E-03   60  12   0   11  14   0   10  14  18    0.000    0.000       0
   0     21 00:00:15.91   0.7580A  -2.3747  -1.2361   1.0256  0.075  0.43  -0.977E+00     40.  0.136E+01  0.195E-01  0.802E-03  0.187E-03   60  11  19   11  14   0   10  14  18    0.000    0.000       0
   0     22 00:00:16.67   0.7580A  -2.3748  -1.2335   1.0516  0.074  0.43  -0.977E+00     40.  0.136E+01  0.200E-01  0.806E-03  0.186E-03   60  11  18   11  14   0   10  14  18    0.000    0.000       0
-  0     23 00:00:17.43   0.7580A  -2.3749  -1.2312   1.0716  0.074  0.44  -0.976E+00     40.  0.136E+01  0.204E-01  0.809E-03  0.185E-03   60  10  17   11  14   0   10  14  18    0.000    0.000       0
-  0     24 00:00:18.19   0.7580A  -2.3749  -1.2294   1.0871  0.074  0.44  -0.975E+00     40.  0.136E+01  0.209E-01  0.812E-03  0.183E-03   60  10  16   11  14   0   11  14  18    0.000    0.000       0
-  0     25 00:00:18.95   0.7580A  -2.3750  -1.2278   1.1145  0.074  0.45  -0.975E+00     40.  0.136E+01  0.214E-01  0.816E-03  0.182E-03   60  10  16   11  14   0   11  14  18    0.000    0.000       0
-  0     26 00:00:19.70   0.7580A  -2.3751  -1.2266   1.1362  0.073  0.45  -0.974E+00     40.  0.136E+01  0.219E-01  0.821E-03  0.181E-03   60  10  15   11  14   0   11  14  18    0.000    0.000       0
-  0     27 00:00:20.46   0.7580A  -2.3752  -1.2256   1.1514  0.073  0.46  -0.973E+00     40.  0.136E+01  0.224E-01  0.825E-03  0.180E-03   60   9  14   11  14   0   11  14  18    0.000    0.000       0
-  0     28 00:00:21.22   0.7580A  -2.3752  -1.2247   1.1600  0.073  0.46  -0.973E+00     40.  0.136E+01  0.229E-01  0.829E-03  0.179E-03   60   9  13   11  14   0   11  14  18    0.000    0.000       0
-  0     29 00:00:21.98   0.7580A  -2.3753  -1.2236   1.1628  0.073  0.46  -0.973E+00     40.  0.136E+01  0.234E-01  0.834E-03  0.179E-03   60   9  12   11  14   0   11  14  18    0.000    0.000       0
-  0     30 00:00:22.74   0.7580A  -2.3754  -1.2224   1.1611  0.072  0.47  -0.972E+00     40.  0.136E+01  0.239E-01  0.840E-03  0.178E-03   60   8  11   11  14   0   11  14  18    0.000    0.000       0
-  0     31 00:00:23.49   0.7580A  -2.3755  -1.2207   1.1566  0.072  0.47  -0.972E+00     40.  0.136E+01  0.244E-01  0.846E-03  0.178E-03   60   8  10   11  14   0   11  14  18    0.000    0.000       0
-  0     32 00:00:24.25   0.7580A  -2.3755  -1.2184   1.1530  0.072  0.47  -0.972E+00     40.  0.136E+01  0.250E-01  0.853E-03  0.177E-03   60   8  10   11  14   0   13  14  18    0.000    0.000       0
-  0     33 00:00:25.01   0.7580A  -2.3756  -1.2150   1.1594  0.072  0.48  -0.972E+00     40.  0.136E+01  0.255E-01  0.860E-03  0.177E-03   60   7   9   11  14   0   13  14  18    0.000    0.000       0
-  0     34 00:00:25.77   0.7580A  -2.3757  -1.2104   1.1885  0.072  0.48  -0.972E+00     40.  0.136E+01  0.261E-01  0.866E-03  0.177E-03   60   7   8   11  14   0   11  14  17    0.000    0.000       0
-  0     35 00:00:26.53   0.7580A  -2.3758  -1.2042   1.2133  0.071  0.48  -0.972E+00     40.  0.136E+01  0.266E-01  0.874E-03  0.177E-03   60   7   7   11  14   0   11  14  17    0.000    0.000       0
-  0     36 00:00:27.28   0.7580A  -2.3759  -1.1961   1.2278  0.071  0.49  -0.971E+00     40.  0.136E+01  0.272E-01  0.881E-03  0.177E-03   60   6   6   11  14   0   11  14  17    0.000    0.000       0
-  0     37 00:00:28.04   0.7580A  -2.3759  -1.1858   1.2418  0.071  0.49  -0.971E+00     40.  0.136E+01  0.278E-01  0.889E-03  0.177E-03   60   6   5   11  14   0   12  14  17    0.000    0.000       0
-  0     38 00:00:28.80   0.7580A  -2.3760  -1.1731   1.2645  0.071  0.49  -0.971E+00     40.  0.136E+01  0.284E-01  0.896E-03  0.178E-03   60   6   5   11  14   0   14  14  16    0.000    0.000       0
-  0     39 00:00:29.56   0.7580A  -2.3761  -1.1617   1.2916  0.071  0.50  -0.971E+00     40.  0.136E+01  0.290E-01  0.905E-03  0.178E-03   60   5   3   11  13   0   14  14  16    0.000    0.000       0
-  0     40 00:00:30.32   0.7580A  -2.3762  -1.1508   1.3247  0.071  0.50  -0.970E+00     40.  0.136E+01  0.296E-01  0.914E-03  0.179E-03   60   5   3   11  13   0   12  14  16    0.000    0.000       0
-  0     41 00:00:31.07   0.7580A  -2.3762  -1.1366   1.3565  0.070  0.50  -0.970E+00     40.  0.136E+01  0.302E-01  0.923E-03  0.179E-03   60   5   2   11  13   0   13  14  16    0.000    0.000       0
+  0     23 00:00:17.43   0.7580A  -2.3749  -1.2312   1.0715  0.074  0.44  -0.976E+00     40.  0.136E+01  0.204E-01  0.809E-03  0.185E-03   60  10  17   11  14   0   10  14  18    0.000    0.000       0
+  0     24 00:00:18.19   0.7580A  -2.3749  -1.2294   1.0870  0.074  0.44  -0.975E+00     40.  0.136E+01  0.209E-01  0.812E-03  0.183E-03   60  10  16   11  14   0   11  14  18    0.000    0.000       0
+  0     25 00:00:18.95   0.7580A  -2.3750  -1.2279   1.1144  0.074  0.45  -0.975E+00     40.  0.136E+01  0.214E-01  0.817E-03  0.182E-03   60  10  16   11  14   0   11  14  18    0.000    0.000       0
+  0     26 00:00:19.70   0.7580A  -2.3751  -1.2267   1.1361  0.073  0.45  -0.974E+00     40.  0.136E+01  0.219E-01  0.821E-03  0.181E-03   60  10  15   11  14   0   11  14  18    0.000    0.000       0
+  0     27 00:00:20.46   0.7580A  -2.3752  -1.2257   1.1513  0.073  0.45  -0.974E+00     40.  0.136E+01  0.224E-01  0.825E-03  0.180E-03   60   9  14   11  14   0   11  14  18    0.000    0.000       0
+  0     28 00:00:21.22   0.7580A  -2.3752  -1.2247   1.1598  0.073  0.46  -0.973E+00     40.  0.136E+01  0.229E-01  0.829E-03  0.179E-03   60   9  13   11  14   0   11  14  18    0.000    0.000       0
+  0     29 00:00:21.98   0.7580A  -2.3753  -1.2237   1.1627  0.073  0.46  -0.973E+00     40.  0.136E+01  0.234E-01  0.834E-03  0.179E-03   60   9  12   11  14   0   11  14  18    0.000    0.000       0
+  0     30 00:00:22.74   0.7580A  -2.3754  -1.2224   1.1610  0.072  0.47  -0.973E+00     40.  0.136E+01  0.239E-01  0.840E-03  0.178E-03   60   8  11   11  14   0   11  14  18    0.000    0.000       0
+  0     31 00:00:23.49   0.7580A  -2.3755  -1.2208   1.1565  0.072  0.47  -0.973E+00     40.  0.136E+01  0.244E-01  0.846E-03  0.178E-03   60   8  10   11  14   0   11  14  18    0.000    0.000       0
+  0     32 00:00:24.25   0.7580A  -2.3755  -1.2184   1.1529  0.072  0.47  -0.972E+00     40.  0.136E+01  0.250E-01  0.853E-03  0.177E-03   60   8  10   11  14   0   13  14  18    0.000    0.000       0
+  0     33 00:00:25.01   0.7580A  -2.3756  -1.2152   1.1592  0.072  0.48  -0.972E+00     40.  0.136E+01  0.255E-01  0.860E-03  0.177E-03   60   7   9   11  14   0   13  14  18    0.000    0.000       0
+  0     34 00:00:25.77   0.7580A  -2.3757  -1.2106   1.1881  0.072  0.48  -0.972E+00     40.  0.136E+01  0.261E-01  0.866E-03  0.177E-03   60   7   8   11  14   0   11  14  17    0.000    0.000       0
+  0     35 00:00:26.53   0.7580A  -2.3758  -1.2044   1.2129  0.071  0.48  -0.972E+00     40.  0.136E+01  0.266E-01  0.873E-03  0.177E-03   60   7   7   11  14   0   11  14  17    0.000    0.000       0
+  0     36 00:00:27.28   0.7580A  -2.3759  -1.1963   1.2274  0.071  0.49  -0.972E+00     40.  0.136E+01  0.272E-01  0.881E-03  0.177E-03   60   6   6   11  14   0   11  14  17    0.000    0.000       0
+  0     37 00:00:28.04   0.7580A  -2.3759  -1.1861   1.2413  0.071  0.49  -0.971E+00     40.  0.136E+01  0.278E-01  0.889E-03  0.177E-03   60   6   5   11  14   0   12  14  17    0.000    0.000       0
+  0     38 00:00:28.80   0.7580A  -2.3760  -1.1734   1.2643  0.071  0.49  -0.971E+00     40.  0.136E+01  0.284E-01  0.896E-03  0.178E-03   60   6   5   11  14   0   14  14  16    0.000    0.000       0
+  0     39 00:00:29.56   0.7580A  -2.3761  -1.1620   1.2914  0.071  0.50  -0.971E+00     40.  0.136E+01  0.290E-01  0.905E-03  0.178E-03   60   5   3   11  13   0   14  14  16    0.000    0.000       0
+  0     40 00:00:30.32   0.7580A  -2.3762  -1.1512   1.3240  0.071  0.50  -0.971E+00     40.  0.136E+01  0.296E-01  0.914E-03  0.179E-03   60   5   3   11  13   0   12  14  16    0.000    0.000       0
+  0     41 00:00:31.07   0.7580A  -2.3762  -1.1371   1.3558  0.070  0.50  -0.971E+00     40.  0.136E+01  0.302E-01  0.922E-03  0.179E-03   60   5   2   11  13   0   13  14  16    0.000    0.000       0